/*==============================================================================*/
/*  Copyright (C) 2009-2016, Heartland Data inc. All Rights Reserved.           */
/*                                                                              */
/*  Title  :   Android Framework Data Writing Driver                            */
/*  EventID:   Via the driver                                                   */
/*  AppVer :   DT10 Ver10.XX`@                                                */
/*  FileID :   43b                                                              */
/*  Version:   2.1                                                              */
/*  Author :   HLDC                                                             */
/*==============================================================================*/

/*==============================================================================*/
/*  Please customize the code for your environment.                             */
/*==============================================================================*/
#include "jni.h"
#include "JNIHelp.h"
#include "android_runtime/AndroidRuntime.h"

extern "C" void _TP_BusOut(unsigned int addr, unsigned int data);
extern "C" void _TP_MemoryOutput(unsigned int addr, unsigned int data, void *value, unsigned int size);

namespace android {
/*==============================================================================*/
/*  JNI Function                                                                */
/*==============================================================================*/
static void android_util_DtTestPointDriver_TPBusOut(JNIEnv *env, jobject obj, jint nAddress, jint nData)
{
	_TP_BusOut(nAddress, nData);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_b(JNIEnv *env, jobject obj, jint nAddress, jint nData, jbyte theValue, jint size)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_c(JNIEnv *env, jobject obj, jint nAddress, jint nData, jchar theValue, jint size)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_s(JNIEnv *env, jobject obj, jint nAddress, jint nData, jshort theValue, jint size)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_i(JNIEnv *env, jobject obj, jint nAddress, jint nData, jint theValue, jint size)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_l(JNIEnv *env, jobject obj, jint nAddress, jint nData, jlong theValue, jint size)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_bl(JNIEnv *env, jobject obj, jint nAddress, jint nData, jboolean theValue, jint size)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_ba(JNIEnv *env, jobject obj, jint nAddress, jint nData, jbyteArray theValue, jint size, jint nLength)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size*nLength);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_ca(JNIEnv *env, jobject obj, jint nAddress, jint nData, jcharArray theValue, jint size, jint nLength)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size*nLength);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_sa(JNIEnv *env, jobject obj, jint nAddress, jint nData, jshortArray theValue, jint size, jint nLength)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size*nLength);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_ia(JNIEnv *env, jobject obj, jint nAddress, jint nData, jintArray theValue, jint size, jint nLength)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size*nLength);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_la(JNIEnv *env, jobject obj, jint nAddress, jint nData, jlongArray theValue, jint size, jint nLength)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size*nLength);
}

static void android_util_DtTestPointDriver_TPMemoryOutput_bla(JNIEnv *env, jobject obj, jint nAddress, jint nData, jbooleanArray theValue, jint size, jint nLength)
{
	_TP_MemoryOutput(nAddress, nData, (void *)&theValue, size*nLength);
}

static JNINativeMethod methods[] = {
{"TPBusOut", "(II)V", (void*)android_util_DtTestPointDriver_TPBusOut },
{"TPMemoryOutput", "(IIBI)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_b },
{"TPMemoryOutput", "(IICI)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_c },
{"TPMemoryOutput", "(IISI)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_s },
{"TPMemoryOutput", "(IIII)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_i },
{"TPMemoryOutput", "(IIJI)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_l },
{"TPMemoryOutput", "(IIZI)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_bl },
{"TPMemoryOutput", "(II[BII)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_ba },
{"TPMemoryOutput", "(II[CII)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_ca },
{"TPMemoryOutput", "(II[SII)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_sa },
{"TPMemoryOutput", "(II[III)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_ia },
{"TPMemoryOutput", "(II[JII)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_la },
{"TPMemoryOutput", "(II[ZII)V", (void*)android_util_DtTestPointDriver_TPMemoryOutput_bla },
};

int register_android_util_DtTestPointDriver(JNIEnv* env)
{
    int result = android::AndroidRuntime::registerNativeMethods(env,
                                            "android/util/DtTestPointDriver",
                                            methods,
                                            NELEM(methods));
    return result;
}

}; /* namespace android */

